; CleanBig/theme.jl

;; Copyright (C) 1999 Red Hat, Inc., <jrb@redhat.com>

;; This theme was based on the CleanBig enlightenment theme created by
;; Michael Fulbright <drmike@redhat.com> and Carsten Haitzler
;; <raster@valinux.com>.  It is inspired by a certain, very popular
;; operating system.


;; The font
(defvar CleanBig:font (get-font "-adobe-helvetica-medium-r-normal-*-*-140-*-*-p-*-iso8859-1"))

;; images
;; The standard images
;; 2x6
(defvar CleanBig:bottom-images (make-image "bottom.png"))

;; 16x3
(defvar CleanBig:top-images (list (make-image "top_inactive.png")
				  (make-image "top_active.png")))

;; 26x19
(defvar CleanBig:title-bar-images (list (make-image "title_bar_inactive.png")
					(make-image "title_bar_active.png")))

;; 3x22
(defvar CleanBig:top-right-images (make-image "top_right.png"))

;; 53x22
(defvar CleanBig:top-right-button-box-images (list (make-image "top_right_button_box_inactive.png")
						   (make-image "top_right_button_box_active.png")))

;; 25x25
(defvar CleanBig:bottom-left-images (make-image "bottom_left.png"))

;; 25x25
(defvar CleanBig:bottom-right-images (make-image "bottom_right.png"))

;; 16x16
(defvar CleanBig:close-images (list (make-image "close_normal.png")
				    nil nil
				    (make-image "close_clicked.png")))

;; 16x16
(defvar CleanBig:maximize-images (list (make-image "maximize_active.png")
				       nil nil
				       (make-image "maximize_clicked.png")))

;; 16x16
(defvar CleanBig:iconify-images (list (make-image "minimize_active.png")
				      nil nil
				      (make-image "minimize_clicked.png")))

;; 22x22
(defvar CleanBig:menu-images (list (make-image "menu_inactive.png")
				   (make-image "menu_active.png")))

;; 6x19
(defvar CleanBig:left-images (make-image "left.png"))

;; 6x19
(defvar CleanBig:right-images (make-image "right.png"))

;; For the transients
;; 19x22
(defvar CleanBig:t-top-right-button-box-images (list (make-image "t_top_right_button_box_inactive.png")
						     (make-image "t_top_right_button_box_active.png")))



;; For the shaded window
;; 22x22
(defvar CleanBig:s-menu-images (list (make-image "s_menu_inactive.png")
				     (make-image "s_menu_active.png")))


;; 56x22
(defvar CleanBig:s-top-right-images (list (make-image "s_top_right_inactive.png")
					  (make-image "s_top_right_active.png")))


;; For the Shaped, transient windows
;; 22x22
(defvar CleanBig:st-top-right-images (list (make-image "st_top_right_inactive.png")
					   (make-image "st_top_right_active.png")))


;; frame layout
(defvar CleanBig:frame
  `(
    ;; title bar
    ((background . ,CleanBig:title-bar-images)
     (foreground . ("black" "white"))
     (font . ,CleanBig:font)
     (text . window-name)
     (x-justify . 4)
     (y-justify . (lambda () (- center 1)))
     (top-edge . -19)
     (left-edge . 16)
     (right-edge . 50)
     (class . title))

    ;; top image
    ((background . ,CleanBig:top-images)
     (top-edge . -22)
     (left-edge . 16)
     (right-edge . 50)
     (class . top-border))
 
    ;; menu button
    ((background . ,CleanBig:menu-images)
     (top-edge . -22)
     (left-edge . -6)
     (class . menu-button))

    ;; left border
    ((background . ,CleanBig:left-images)
     (left-edge . -6)
     (top-edge . 0)
     (bottom-edge . 19)
     (class . left-border))

    ;; top-right corner
    ((background . ,CleanBig:top-right-images)
     (right-edge . -6)
     (top-edge . -22)
     (class . top-right-corner))

    ;; top-right-button-box corner
    ((background . ,CleanBig:top-right-button-box-images)
     (right-edge . -3)
     (top-edge . -22)
     (class . title))

    ;; right border
    ((background . ,CleanBig:right-images)
     (right-edge . -6)
     (top-edge . 0)
     (bottom-edge . 0)
     (class . right-border))

    ;; bottom border
    ((background . ,CleanBig:bottom-images)
     (left-edge . 17)
     (right-edge . 19)
     (bottom-edge . -6)
     (class . bottom-border))

    ;; bottom-left corner
    ((background . ,CleanBig:bottom-left-images)
     (left-edge . -6)
     (bottom-edge . -6)
     (class . bottom-left-corner))

    ;; bottom-right corner
    ((background . ,CleanBig:bottom-right-images)
     (right-edge . -6)
     (bottom-edge . -6)
     (class . bottom-right-corner))

    ;; iconify button
    ((background . ,CleanBig:iconify-images)
     (right-edge . 31)
     (top-edge . -19)
     (class . iconify-button))

    ;; maximize button
    ((background . ,CleanBig:maximize-images)
     (right-edge . 14)
     (top-edge . -19)
     (class . maximize-button))

    ;; delete button
    ((background . ,CleanBig:close-images)
     (right-edge . -3)
     (top-edge . -19)
     (class . close-button))
    ))


; Shaped
(defvar CleanBig:shaped-frame
  `(
    ;; title bar
    ((background . ,CleanBig:title-bar-images)
     (foreground . ("black" "white"))
     (font . ,CleanBig:font)
     (text . window-name)
     (x-justify . 4)
     (y-justify . center)
     (top-edge . -19)
     (left-edge . 16)
     (right-edge . 50)
     (class . title))

    ;; menu button
    ((background . ,CleanBig:s-menu-images)
     (top-edge . -22)
     (left-edge . -6)
     (class . menu-button))


    ;; top image
    ((background . ,CleanBig:top-images)
     (top-edge . -22)
     (left-edge . 16)
     (right-edge . 50)
     (class . title))

    ;; top-right corner
    ((background . ,CleanBig:s-top-right-images)
     (right-edge . -6)
     (top-edge . -22)
     (class . title))

    ;; iconify button
    ((background . ,CleanBig:iconify-images)
     (right-edge . 31)
     (top-edge . -19)
     (class . iconify-button))

    ;; maximize button
    ((background . ,CleanBig:maximize-images)
     (right-edge . 14)
     (top-edge . -19)
     (class . maximize-button))

    ;; delete button
    ((background . ,CleanBig:close-images)
     (right-edge . -3)
     (top-edge . -19)
     (class . close-button))
    ))


; Transient
(defvar CleanBig:transient-frame
  `(
    ;; title bar
    ((background . ,CleanBig:title-bar-images)
     (foreground . ("black" "white"))
     (font . ,CleanBig:font)
     (text . window-name)
     (x-justify . 4)
     (y-justify . center)
     (top-edge . -19)
     (left-edge . 16)
     (right-edge . 16)
     (class . title))

    ;; top image
    ((background . ,CleanBig:top-images)
     (top-edge . -22)
     (left-edge . 16)
     (right-edge . 16)
     (class . top-border))
 
    ;; menu button
    ((background . ,CleanBig:menu-images)
     (top-edge . -22)
     (left-edge . -6)
     (class . menu-button))

    ;; left border
    ((background . ,CleanBig:left-images)
     (left-edge . -6)
     (top-edge . 0)
     (bottom-edge . 19)
     (class . left-border))

    ;; top-right corner
    ((background . ,CleanBig:top-right-images)
     (right-edge . -6)
     (top-edge . -22)
     (class . top-right-corner))

    ;; top-right-button-box corner
    ((background . ,CleanBig:t-top-right-button-box-images)
     (right-edge . -3)
     (top-edge . -22)
     (class . title))

    ;; right border
    ((background . ,CleanBig:right-images)
     (right-edge . -6)
     (top-edge . 0)
     (bottom-edge . 0)
     (class . right-border))

    ;; bottom border
    ((background . ,CleanBig:bottom-images)
     (left-edge . 17)
     (right-edge . 19)
     (bottom-edge . -6)
     (class . bottom-border))

    ;; bottom-left corner
    ((background . ,CleanBig:bottom-left-images)
     (left-edge . -6)
     (bottom-edge . -6)
     (class . bottom-left-corner))

    ;; bottom-right corner
    ((background . ,CleanBig:bottom-right-images)
     (right-edge . -6)
     (bottom-edge . -6)
     (class . bottom-right-corner))

    ;; delete button
    ((background . ,CleanBig:close-images)
     (right-edge . -3)
     (top-edge . -19)
     (class . close-button))
    ))


; Shaped-transient
(defvar CleanBig:shaped-transient-frame
  `(
    ;; title bar
    ((background . ,CleanBig:title-bar-images)
     (foreground . "white")
     (font . ,CleanBig:font)
     (text . window-name)
     (x-justify . 4)
     (y-justify . center)
     (top-edge . -19)
     (left-edge . 16)
     (right-edge . 16)
     (class . title))

    ;; menu button
    ((background . ,CleanBig:s-menu-images)
     (top-edge . -22)
     (left-edge . -6)
     (class . menu-button))

    ;; top image
    ((background . ,CleanBig:top-images)
     (top-edge . -22)
     (left-edge . 16)
     (right-edge . 16)
     (class . title))

    ;; top-right corner
    ((background . ,CleanBig:st-top-right-images)
     (right-edge . -6)
     (top-edge . -22)
     (class . title))

    ;; delete button
    ((background . ,CleanBig:close-images)
     (right-edge . -3)
     (top-edge . -19)
     (class . close-button))
    ))


;; Frame definition
(defun CleanBig:frame-style (w type)
  (cond ((eq type 'shaped)
	 'CleanBig:shaped-frame)
	((eq type 'transient)
	 'CleanBig:transient-frame)
	((eq type 'shaped-transient)
	 'CleanBig:shaped-transient-frame)
	((eq type 'unframed)
	 'nil-frame)
	(t
	 'CleanBig:frame)))

(add-frame-style 'CleanBig 'CleanBig:frame-style)
